/*  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdlib.h> // rand, srand
#include <string.h> // strcmp, strcpy, memcpy
#include <io.h>     // _finddata_t, _findfirst, _findnext, _findclose
#include <stdio.h>  // printf, fwrite, fclose, sprintf, fopen, FILE
#include <time.h>   // time

// How many maps to actually get processed
static unsigned short menunamecnt;

// Get all the map names
static int getfilenames(char *kind);

// Sort the map names
static void sortfilenames();

#define MAXMENUFILES 80 // Blood can only make 80 level entries (5 * 16)

// The actual map names
static char menuname[MAXMENUFILES][32];

// Has to be global for some reason...
static FILE *ini;

int main(int argc, char* argv[])
{
	unsigned short i, j, midi, CDTrack, buffercount;
    char *MidiSong, MapTitle[9], buffer[80], *tbuffer;
    srand ((unsigned)time(NULL));
    

    menunamecnt = 0;
	getfilenames("*.map");
	sortfilenames();
        
    if (menunamecnt == 0)
    {
        printf("No maps here!\n");
        return -1;
    }
    
    if (argc > 1)
    ini = fopen(argv[1],"w+t");
    else
    ini = fopen("my.ini","w+t");
       
    for(i=0;i<menunamecnt;i++)
    {
        if (i/16 >= 6) // No more than 6 episodes
                break;
        
        // To get just the map title
        for ( j=0; menuname[i][j] != '.'; j++)
        MapTitle[j] = menuname[i][j];
        
        MapTitle[j] = '\0';
        
        
        if (i%16 == 0 || i == 0) 
        {
            if (i == 0)
                tbuffer ="[EPISODE1]\n\n";
            else 
                sprintf(tbuffer,"[EPISODE%d]\n\n", ((i+1)/16) +1);

            buffercount = 0;
            while (tbuffer[buffercount] != '\0')
            {
                fwrite(&tbuffer[buffercount],sizeof (char),1,ini);
                buffercount++;
            }
        
            if (i == 0)
                tbuffer="Title\t\t= A few good maps part 1\n\n";
            else
                sprintf(tbuffer,"Title\t\t= A few good maps part %d\n\n", ((i+1)/16) +1);

            buffercount = 0;
            while (tbuffer[buffercount] != '\0')
            {
                fwrite(&tbuffer[buffercount],sizeof (char),1,ini);
                buffercount++;
            }
        } // if 

        if (i<16) // to prevent dividing by a bigger number
            sprintf(buffer, "Map%d\t\t= %s\n", i+1, MapTitle);
        else
            sprintf(buffer, "Map%d\t\t= %s\n", (i%16) + 1, MapTitle);
        
        buffercount = 0;
        while (buffer[buffercount] != '\0')
        {
            fwrite(&buffer[buffercount],sizeof (char),1,ini);
            buffercount++;
        }
        if ((i%16) + 1 == 16)
            fwrite("\n",sizeof (char),1,ini);
            
    }

// This for chunk defines the actual map specfic stuff
    for(i=0;i<menunamecnt;i++)
    {
        if (i/16 >= 6)
                break;        
        // To get just the map title
        for ( j=0; menuname[i][j] != '.' ; j++)
        MapTitle[j] = menuname[i][j];
                
        MapTitle[j] = '\0';
        
        // Map Title
        sprintf(buffer, "[%s]\n", MapTitle);
        buffercount = 0;
        while (buffer[buffercount] != '\0')
        {
            fwrite(&buffer[buffercount],sizeof (char),1,ini);
            buffercount++;
        }
        
        // Title tag
        sprintf(buffer, "Title\t\t= %s\n", MapTitle);
        buffercount = 0;
        while (buffer[buffercount] != '\0')
        {
            fwrite(&buffer[buffercount],sizeof (char),1,ini);
            buffercount++;
        }
        
        // A random midi file to DM by.
        midi = (rand()%12) + 1;

        switch (midi)
        {
        case 1:
        MidiSong = "CBLOOD1";
        break;
        case 2:
        MidiSong = "CBLOOD2";
        break;
        case 3:
        MidiSong = "CBLOOD3";
        break;
        case 4:
        MidiSong = "CBLOOD4";
        break;
        case 5:
        MidiSong = "CBLOOD5";
        break;
        case 6:
        MidiSong = "CBLOOD6";
        break;
        case 7:
        MidiSong = "CBLOOD7";
        break;
        case 8:
        MidiSong = "CBLOOD8";
        break;
        case 9:
        MidiSong = "CBLOOD9";
        break;
        case 10:
        MidiSong = "CBLOOD10";
        break;
        case 11:
        MidiSong = "UNHOLY";
        break;
        case 12:
        MidiSong = "PESTIS";
        break;
        default:
        MidiSong = "UNHOLY";
        } // switch
        sprintf(buffer,"Song\t\t= %s\n", MidiSong);
        buffercount = 0;
        while (buffer[buffercount] != '\0')
        {
            fwrite(&buffer[buffercount],sizeof (char),1,ini);
            buffercount++;
        }

        // Now for a random CD track to jam out to.
        CDTrack = (rand()%9) + 1;
        sprintf(buffer,"Track\t\t= %d\n", CDTrack);
        buffercount = 0;
        while (buffer[buffercount] != '\0')
        {
            fwrite(&buffer[buffercount],sizeof (char),1,ini);
            buffercount++;
        }
        
        
        if ((i+1)%16 != 0)
        {
            if ( i == 15)
                i++;
            // Now for EndingA
            sprintf(buffer,"EndingA\t\t= %d\n", ((i+1)%16) +1);
            buffercount = 0;
            while (buffer[buffercount] != '\0')
            {
                fwrite(&buffer[buffercount],sizeof (char),1,ini);
                buffercount++;
            }
        
            // And EndingB
            sprintf(buffer,"EndingB\t\t= %d\n\n", ((i+1)%16) +1);
            buffercount = 0;
            while (buffer[buffercount] != '\0')
            {
                fwrite(&buffer[buffercount],sizeof (char),1,ini);
                buffercount++;
            }
            if ( i == 15)
                i--;

        }
        else
            fwrite("\n",sizeof (char),1,ini);

    } // for
    fclose(ini);
         
    return 0;
}

static int getfilenames(char *kind)
{
	short type;
	struct _finddata_t fileinfo;
    long handle;

	if (strcmp(kind,"SUBD") == 0)
	{
		strcpy(kind,"*.map");
        handle = _findfirst(kind,&fileinfo); 
		if (handle != 0) 
			return(-1);
		type = 1;
	}
	else
	{
		handle = _findfirst(kind,&fileinfo); 
		if (handle == -1) 
            return(-1);
        else
            type = 0;
            
	}
	do
	{
		if ((type == 0) || ((fileinfo.attrib&16) > 0))
			if ((fileinfo.name[0] != '.') || (fileinfo.name[1] != 0))
			{
				if (menunamecnt < MAXMENUFILES)
				{
					strcpy(menuname[menunamecnt],fileinfo.name);
					menuname[menunamecnt][16] = (char)type;
					menunamecnt++;
                }
				else
				    printf("Too many files! (max=MAXMENUFILES)");
			}
	}
	while (_findnext(handle, &fileinfo) == 0);
    
    _findclose(handle);

	return(0);
}

static void sortfilenames()
{
	char sortbuffer[32];
	long i, j, k;

	for(i=1;i<menunamecnt;i++)
		for(j=0;j<i;j++)
		{
			 k = 0;
			 while ((menuname[i][k] == menuname[j][k]) && (menuname[i][k] != 0) && (menuname[j][k] != 0))
				 k++;
			if (menuname[i][k] < menuname[j][k])
			{
				memcpy(&sortbuffer[0],&menuname[i][0],sizeof(menuname[0]));
				memcpy(&menuname[i][0],&menuname[j][0],sizeof(menuname[0]));
				memcpy(&menuname[j][0],&sortbuffer[0],sizeof(menuname[0]));
			}
		}
}
